/* Created by Anjuta version 1.0.2 */
/*	This file will not be overwritten */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "config.h"
#include "../include/dosya_okuma.h"

/*
Bu fonksiyon verilen bir config dosyasinin icinden # ile baslayan yorum
satirlarini atar,satir baslarindaki bosluklari atar ve geri kalan\
satirlari dynamic olarak satirlar[i] seklinde geri dondurur\
Bu dizinin isi bittiginde hafizalar free ile serbest birakilmalidir.
*/
char **dosya_satirlarini_getir(char *dosya_adi, int *satir_sayisi)
{
	int i, ilk_karakter=1, satir_uzunlugu=0, karakter, atla=0;
	int toplam_satir_sayisi=0, *satir_uzunluklari;
	char **satirlar;
	FILE *dosya;

    if( !(dosya=fopen(dosya_adi, "r")) ) {
    	printf("%s dosyasi acilamadi !", dosya_adi);
		exit(1);
    }
	
	//Dosyadaki toplam satir sayisini bul
	while( (karakter=fgetc(dosya)) != EOF ) toplam_satir_sayisi++;
	fclose(dosya);
	
	//Dosya bos
	if( !toplam_satir_sayisi ) return NULL;

	dosya=fopen(dosya_adi, "r");
	
	//Dosyadaki satir uzunluklarini goseterecek boyutlu int degisken icin yer ayir
	if( !(satir_uzunluklari=(int*)malloc( toplam_satir_sayisi*sizeof(int)) ) ) {
		puts("Hafiza yok !"); exit(0);
	}
	
	//Burada dosyada gecerli satirlarin uzunluklari bulunup, satir_uzunluklari
	//degiskenine atanacak
	*satir_sayisi=0; satir_uzunlugu=0;
	while( (karakter=fgetc(dosya)) != EOF ){
		if( ilk_karakter ) {
			//ilk_karakter newline veya bosluk ise bir sonraki karakteri okumak icin tekrar basla
			if( karakter =='\n' || karakter == ' ') continue;
				
			//ilk karakter # ise bu satir sonuna kadar okunacak
			//fakat okunan karakterler atlanacak,
			if( karakter=='#' ) {
				ilk_karakter=0; atla=1; 
				continue;
			}
		}
		//satir # ile baslamis ise satir sonuna kadarki karakterler atlanacak
		if( atla ) {
			if( karakter=='\n') { 
				atla=0; ilk_karakter=1;
			}
			continue;
		}
#ifdef DEBUG
		putchar(karakter);
#endif
		if( karakter=='\n' ) {
#ifdef DEBUG
			printf("satir uzunlugu=%d\n", satir_uzunlugu);
#endif
			// newline bulunduguna gore satir sayisini arttir
			// ve yeni satirin ilk karakteri gelecegini goster
			satir_uzunluklari[(*satir_sayisi)++]=satir_uzunlugu+1; //her satirin uzunlugunu al
			satir_uzunlugu=0; ilk_karakter=1;
		} 
		else { 
			ilk_karakter=0; //satir devam ediyor
			satir_uzunlugu++;
		}
	}
	fclose(dosya);
#ifdef DEBUG	
	printf("Satir sayisi:%d\n", *satir_sayisi);
	for(i=0; i<4; i++) 
		printf("uzunluklar[%d]:%d\n", i, satir_uzunluklari[i]);
#endif	
	
	dosya=fopen(dosya_adi, "r");
	//
	//Dosyanin toplam satir sayisi ve her satirin uzunlugu belirlendi
	//Simdi dosya satirlar[] icine dinamik olarak alinacak
	//Her satir icin satirin uzunlugu kadar yer ayrilacak
	//
	satirlar=(char **)malloc( sizeof(char*)*(*satir_sayisi));
	for(i=0; i<*satir_sayisi; i++) {
		satirlar[i]=(char*)malloc( sizeof(char*)*satir_uzunluklari[i] );
	}
	
	*satir_sayisi=0; satir_uzunlugu=0; i=0; //Satir icinde kacinci karakterin okundugunu gosteriyor
	while( (karakter=fgetc(dosya)) != EOF ){
		if( ilk_karakter ) {
			//ilk_karakter newline veya bosluk ise bir sonraki karakteri okumak icin tekrar basla
			if( karakter =='\n' || karakter == ' ') continue;
				
			//ilk karakter # ise bu satir sonuna kadar okunacak
			//fakat okunan karakterler atlanacak,
			if( karakter=='#' ) {
				ilk_karakter=0; atla=1; 
				continue;
			}
		}
		//satir # ile baslamis ise satir sonuna kadarki karakterler atlanacak
		if( atla ) {
			if( karakter=='\n') { 
				atla=0; ilk_karakter=1;
			}
			continue;
		}
#ifdef DEBUG
		putchar(karakter);
#endif
		satirlar[*satir_sayisi][i++]=(char)karakter;
		if( karakter=='\n' ) {
#ifdef DEBUG
			printf("satir uzunlugu=%d\n", satir_uzunlugu);
#endif
			// newline bulunduguna gore satir sayisini arttir
			// ve yeni satirin ilk karakteri gelecegini goster
			satir_uzunlugu=0; ilk_karakter=1;
			satirlar[(*satir_sayisi)++][--i]=(char)NULL;
			i=0;			
		} 
		else { 
			ilk_karakter=0; //satir devam ediyor
			satir_uzunlugu++;
		}
	}	
	fclose(dosya);
#ifdef DEBUG	
	printf("Satir sayisi:%d\n", *satir_sayisi);
	for(i=0; i<*satir_sayisi; i++)
		printf("satir[%d]:%s\n", i, satirlar[i]);
#endif
	
	free(satir_uzunluklari);
	return(satirlar);	
}
